unit Uaddus;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, ComCtrls, ToolWin;

type
  TfmAddus = class(TForm)
    sgUsels: TStringGrid;
    tbAddus: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    procedure FormActivate(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TUsel=Record
     Num:integer;
     Ts:string[5];
     Nts:string[6];
     days:integer;
     Graf_Num:integer;
     end;

  TFileUsel=file of TUsel;
  var
  fmAddus: TfmAddus;
  fileusel: tfileusel;
implementation

{$R *.DFM}



procedure TfmAddus.FormActivate(Sender: TObject);

var
   usels: integer;
   usel: TUsel;
   FileUsel: tfileusel;
begin
  AssignFile(FileUsel,'Usel.dat');
  Reset(FileUsel);
   sgusels.Cells[0,0]:=' ';
   sgusels.Cells[1,0]:='';
   sgusels.Cells[2,0]:='';
   sgusels.Cells[3,0]:='';

   sgusels.RowCount:= filesize(fileusel)+1;

  Usels:=0;
             While not eof(FileUsel) do
             begin
                  Read(FileUsel,Usel);
                  usels:=Usels+1;
                  sgusels.Cells[0,usels]:=inttostr(Usel.num);
                  sgusels.Cells[1,usels]:=Usel.Ts;
                  sgusels.Cells[2,usels]:=Usel.Nts;
                  sgusels.Cells[3,usels]:=inttostr(Usel.days);
             end;
  closefile(FileUsel);

end;

function verifymatrix : boolean;
var i,j: integer;
begin
  verifymatrix:=true;
  for i:=1 to fmaddus.sgusels.rowcount-1 do
    for j:=1 to fmaddus.sgusels.colcount-1 do
      if fmaddus.sgusels.cells[j,i]='' then
      begin
        verifymatrix:=false;
        exit;
      end;
end;


procedure TfmAddus.ToolButton5Click(Sender: TObject);
begin
  fmaddus.Close;
end;

procedure TfmAddus.ToolButton3Click(Sender: TObject);
var i:integer;
    usel:tusel;
begin
  if Not(verifymatrix) then
  begin
    showmessage('  !');
    exit;
  end;
  assignfile(fileusel,'usel.dat');
  rewrite(fileusel);
  for i:=1 to sgusels.RowCount-1 do
  begin
    usel.num:=strtoint(sgusels.Cells[0,i]);
    Usel.Ts:=sgusels.Cells[1,i];
    Usel.Nts:=sgusels.Cells[2,i];
    Usel.days:=strtoint(sgusels.Cells[3,i]);
    usel.graf_num:=0;
    write(fileusel,usel);
  end;
  closefile(fileusel);
  fmaddus.Close;
end;

procedure TfmAddus.ToolButton1Click(Sender: TObject);
begin
  sgusels.RowCount:=sgusels.RowCount+1;
  sgusels.cells[0,sgusels.RowCount-1]:=inttostr(sgusels.RowCount-1);
  sgusels.col:=1;
  sgusels.Row:=sgusels.RowCount-1;
end;

procedure TfmAddus.ToolButton2Click(Sender: TObject);
var i:integer;

begin
 if sgusels.RowCount=2 then
 begin
   showmessage('   !');
   exit;
 end;
 for i:=sgusels.row to sgusels.rowcount-1 do
 begin
   sgusels.Cells[1,i]:=sgusels.Cells[1,i+1];
   sgusels.Cells[2,i]:=sgusels.Cells[2,i+1];
 end;
 sgusels.RowCount:= sgusels.RowCount-1;

end;

end.
